! ----------------------------------------
!  Geosat2trip.f90 - Created by Morgan Brown
!           Mon Jan 29 10:37:23 2001.
! ----------------------------------------
!       Usage:  <geosat.int.HH Geosat2trip.x  > triplets.H
!  Parameters: 
! Description:  Transpose and pass only columns 3,4,5
! ----------------------------------------
program Geosat2trip

use sep

implicit none

integer                              :: ntrk, ndat, idat
real                                 :: d1, d2, o1, o2
integer, dimension(:,:), allocatable :: data
real,    dimension(:,:), allocatable :: xyz

call sep_init(SOURCE)

call from_history( 'n1', ntrk)
if( ntrk /= 7) then
	write(0,*) 'n1 of input file = ',ntrk,', must = 7!'
	call exit(0) 
end if
call from_history( 'n2', ndat)
call to_history( 'n1', ndat)
call to_history( 'n2', 3)

allocate( data(ntrk,ndat), xyz(ndat,3) )
call sreed( 'in', data, 4*ntrk*ndat )

xyz = 0.0

do idat = 1,ndat
	xyz(idat,1) = data(3,idat)/1.0e6
	xyz(idat,2) = data(4,idat)/1.0e6
	xyz(idat,3) = data(5,idat)
end do

call sep_write( xyz)
deallocate( data, xyz )

call exit(0)

end program Geosat2trip
