program Missif
  ! Missif  - find MISSing Input values and Filter 
  ! on the 1-axis to min power out.
  !
  ! <in.H Missif [filtin=fin.H] [filtout=fout.H]  >out.H
  !  input- 
  ! in.H data cube, exact zeros assumed missing values.
  ! filtin  data cube of starting guess filters.
  !   lag=1 is the constrained point of the filter.
  !   if( filtin) then na=n1 and lag comes from fin.H
  !   else na=3 lag=1  from command line
  ! nmiss=n1 iteration count
  !  output-
  ! out.H in.H with the holes filled in.
  ! filtout 1-axis filters that minimize output power.  
  ! (nonlinear CG)
  ! 
  ! BUGS- Missing data values are taken to be those that are zero valued.
  ! Nonlinear iteration is always unpredictable.
  ! No way to average statistics over 2 and 3 axis.
  ! keyword missing data interpolation filter
  !%
  use sep
  use misif

  implicit none
  integer                             :: n1, n2, n3, nmiss, na, lag, i2, i3
  real,    dimension (:), allocatable :: xx, aa,rs_wt
  logical, dimension (:), allocatable :: mm

  call sep_init ()
  call from_history (n1, n2, n3)
  allocate (xx (n1))

  call putlin("Missing data fill in")
  call from_par ("nmiss", nmiss, n1)

  if (exist_file ("filtin")) then
     call from_aux ("filtin", "n1", na)
     call from_aux ("filtin", "lag", lag)
  else 
     call from_par ("na", na, 3)
     call from_par ("lag",lag, 1)
     call putlin("filter in assumed spike")
  end if
  allocate (aa (na))
  allocate (mm (n1 + na),rs_wt(n1+na))

  call to_history ("esize",   4, "filtout")
  call to_history (   "n1",  na, "filtout")
  call to_history (   "n2",  n2, "filtout")
  call to_history (   "n3",  n3, "filtout")
  call to_history (  "lag", lag, "filtout")
  call sep_close () 

write(0,*) n1,n2,n3
write(0,*) 'nmiss', nmiss
rs_wt=1.0
  do i3=1, n3 
     do i2=1, n2 
        if( exist_file ("filtin")) then
           call sep_read (aa, "filtin")
           mm (n1+1:) = (aa == 0.)
        else 
           aa = 0.              ; aa (   lag) = 1.
           mm (n1+1:) = .false. ; mm (n1+lag) = .true.
        end if

        call sep_read (xx) ; mm (1:n1) = (xx /= 0.)

        ! set rs_wt to 1 where xx/=0, where data is known
        where (xx==0.0)
           rs_wt=0.0
        end where
!rs_wt=0.0
!rs_wt(16:)=1.0
!rs_wt(4:5)=0.0
!mm=.true.
!rs_wt(5:7)=0.0
 write(0,*) size(rs_wt),size(xx),size(aa)      
 write(0,*)'wt', rs_wt
write(0,*) 'aa',aa
write(0,*) 'mm',mm
!nmiss=87
       call misif1 (nmiss, xx, aa, mm, rs_wt)
        call sep_write (aa, "filtout")
        call sep_write (xx)
     end do
  end do
write(0,*) xx
  deallocate (aa, xx, mm)
  call exit (0)
end program Missif












