program Wide_mask
  use lint2
  use bin2
  use igrad2
  use laplac2
  use solver_smp_mod
  use solver_prc_mod
  use solver_reg_mod
  use dottest
  use icai1
  use tcai1
  use polydiv
  use helicon
  use cgstep_mod
  use createhelixmod
  use lapfac
  use mad_routines
  use peftc2d
  use sep
  use misif_pef
  use helix
  use helicon_explicit_transient

  implicit none
  integer                            :: n1,n2,m1,m2,na,stat1,stat2,method
  integer                            :: niter,id,ix
  integer                            :: pef1,pef2   
  integer                            ::center1,center2,gap1,gap2,nfilt1,nfilt2
  integer                            :: center(2), gap(2), pef_axis(2), data_axis(2)
  real                               :: o1,o2,d1,d2,xmin,xmax,ymin,ymax
  real                               :: eps,eps_fac
  real,   dimension(:),pointer       :: data_1D,data_1D_grad,data_1D_ones,model_1D,fold_1D,model0,initsol
  real,   dimension(:),pointer       :: wt_in,wt_conv,wt,t_d,pef_in,res,res1,res1_grad,res2,res3,data_2,in_fold,out_fold
  real,   dimension(:),pointer       ::trend_1D,filter_in
  real,   dimension(:)               ::wt_conv2,data_detrend_1D
  real,    dimension( :,:),pointer   :: xy,data_detrend,data_2d,mask_combo,out1,out2,mask_out
  logical                            :: norm,reg,bin,allone

  integer                             :: nmiss, lag,width
  real,    dimension (:), allocatable :: xx, rs_wt,data,in_dat,data_reverse,data_reverse_out
  logical, dimension (:), allocatable :: mm,mask_in



  call sep_init ()
  call initpar()

  call from_history("n1",n1)
  call from_history("n2",n2)
  call from_param("width",width,2)

  allocate( data(n1*n2),data_2d(n1,n2),out1(n1+width-1,n2),out2(n1,n2),mask_combo(n1,n2),mask_out(n1,n2),filter_in(width),data_reverse(n1+width-1),data_reverse_out(n1+width-1+width-1))


  call sreed("in", data_2d, 4*n1*n2) 

  lag=1
  filter_in=1.

  call icai1_init(filter_in,lag)
  call tcai1_init(filter_in)
  out1=0.

  write(0,*) 'filter',filter_in
  do id=1,n2
     !   stat1=icai1_lop(data(1+(id-1)*n1 : n1+(id-1)*n1),out1(1+(id-1)*n1 : n1+(id-1)*n1))
     !   stat1=icai1_lop(.false.,.false.,data_2d(1:,id),out1(1:,id))
     stat1=tcai1_lop(.false.,.false.,data_2d(1:,id),out1(1:,id))

  end do


  do id=1,n2
     ! time reverse
     data_reverse=out1(n1+width-1:1:-1,id)!    data_2d(n1:1:-1,id)
     stat1=icai1_lop(.false.,.false.,data_reverse,data_reverse_out)
     out1(1:n1+width-1,id)=out1(1:n1+width-1,id)+data_reverse_out(n1+width-1:1:-1)
mask_combo(:,id)=out1(1:n1,id) 
  end do
!  mask_combo=0.

  !mask_combo=out1(1:n1,:) 

  mask_out=.0
  !write(0,*) mask_combo
  !  where (mask_combo<=0.00001)
  !     mask_out=0.0 
  !  end where
write(0,*) 'n1/n2',n1,n2
  do id=1,n1
     do ix=1,n2
        if (mask_combo(id,ix)>0.) then
           mask_out(id,ix)=1.
else 
 mask_out(id,ix)=0.
        end if
     end do
  end do
write(0,*) 'n1',n1,size(mask_out)
  ! writ out the model
  call sep_write (mask_out)
  call to_history ("n1",  n1)
  call to_history ("n2",  n2)
  call to_history ("o1",  o1)
  call to_history ("o2",  o2)
  call to_history ("d1",  1.)
  call to_history ("d2",  1.)
  call to_history ("esize",4)

  
end program Wide_mask
