module nmisif_pef  
! MISSIF -- find MISSing Input data and Filter
  use peftc2d
  use peftc2d_short
  use peftc2
  use tcai2
  use cgstep_mod
  use solver_mod
  use helix
  use dottest
  use sep
  use nonlin_igrad2
  use nonlin_igrad1
use ident
!  use igrad2

  implicit none
  contains
    subroutine nmisif_pef1 (niter, xx, aa, mm,rs_wt)
      integer, intent (in)                               :: niter 
      ! iterations
      real,    dimension (:)                             :: xx,rs_wt 
      ! data, PEF
      logical, dimension (:)                             :: mm     
      ! mask
      type(filter) ,intent(in out)                       :: aa
      type(filter)                                       :: aa_dummy
      real,    dimension (:), pointer                    :: xk, bb&
      &,rs_wt_pnt
      real,    dimension (size (xx) + size (aa%flt))         :: dat,mwt
      real,    dimension (size (xx) + size (aa%flt)), target :: x,&
      & rs_targ
      real,    dimension (size (xx),niter)   :: resmovie
    real,    dimension (size (xx)+ size (aa%flt),niter)   :: xmovie
      integer                                            :: nx,stat1,I,id,na,m1,m2
      real,    dimension  (2)   :: dot1,dot2  
      nx = size (xx)
na=size(aa%flt)
m1=400
m2=400
      aa_dummy=aa
      x = 0. ;  dat = 0.
x(1 : nx  )=xx   !delete?	
      xk => x (1 : nx  ) ; where (mm (1 : nx )) xk = xx
      aa_dummy%flt => x (1 + nx :) ; where (mm (1 + nx:)) aa_dummy%flt = aa%flt
      x(1+nx:) = aa%flt
      bb => x (1 + nx :) ; where (mm (1 + nx:)) bb = 1.
      call peftc2d_init (aa_dummy, xk)
      call peftc2_init (aa_dummy%flt, xk)
      call tcai2_init (aa_dummy%flt, nx)
      call peftc2d_short_init (aa_dummy,nx)
call nonlin_igrad2_init(m1,m2,nx)
call nonlin_igrad1_init(nx)
call ident_init(nx)
      write(0,*) 'aa_dummy%flt',aa_dummy%flt
write(0,*) 'nx/na',nx,na
      !call tcai2_init (bb, nx)
      !  call solver (peftc_lop, cgstep, niter = niter, x0 = x, x = x,dat =&
      !         & dat, nloper = tcai2_lop, known = mm,wt=rs_wt,verb=.true.)
      !  & dat)

      !write(0,*) 'xout',x(nx+1:)
      !stop

      write(0,*) 'dottest results a:'
           call dot_test (ident_lop,nx+na ,nx+na ,dot1,dot2)
      write(0,*) 'end dottest'

!!$      write(0,*) 'x before',x
!!$      dat=1.;x(1:size(xx))=(/(I,I=1,size(xx))/)
!!$      write(0,*) 'x before',x
!!$      write(0,*) 'dat',dat
!!$      write(0,*) 'flt',aa_dummy%flt
!!$      stat1=peftc2_lop(.false.,.true.,x ,dat)
!!$      write(0,*) 'x',x
!!$      write(0,*) 'flt',aa_dummy%flt
!!$      write(0,*) 'out1 dat',dat
!!$      x(1:size(xx))=(/(I,I=1,size(xx))/)
!!$dat=1.
!!$      write(0,*) 'aa_dummy_flt',aa_dummy%flt
!!$      stat1=peftc2d_lop(.false.,.true.,x ,dat)
!!$      write(0,*) 'new x',x
!!$      write(0,*) 'out2 dat',dat
!!$      write(0,*) 'aa_dummy_flt',aa_dummy%flt

!!set model weight
mwt(1:nx)=1.
mwt(nx+1:)=.01



            call solver (peftc2d_lop, cgstep, niter = niter, x0 = x, x = x,dat =&
                 & dat, nloper = peftc2d_short_lop, known = mm,wt=rs_wt,verb=.true.,rmov=resmovie,xmov=xmovie) !,mwt=mwt)
  !call solver_reg(peftc2d_lop, cgstep,nonlin_igrad1_lop,2*(na), niter = niter,eps=2., x0 = x, x = x,dat =&
!          & dat, nloper = peftc2d_short_lop,known = mm,wt=rs_wt,verb=.true.,rmov=resmovie,xmov=xmovie)     
   !    & dat, nloper = peftc2d_short_lop,known = mm,wt=rs_wt,verb=.true.,rmov=resmovie,xmov=xmovie)


!model_1D, data_1D,lint2_lop,igrad2_lop,cgstep,m1*m2*2&
!           &,niter,eps,verb=.true.,Wop=madchain_exec,resd=res)



do id=1,niter
resmovie(:,id)=rs_wt*resmovie(:,id)
end do
      !  call solver (peftc2_lop, cgstep, niter = niter, x0 = x, x = x,dat =&
      !       & dat, nloper = tcai2_lop, known = mm)

      call cgstep_close ()

 if(exist_file("rmov"))then  
  call sep_write (resmovie,"rmov")
  call to_history ("n1", size (xx) ,"rmov")
  call to_history ("n2",  niter,"rmov")
  call to_history ("o1",  0.,"rmov")
  call to_history ("o2",  0.,"rmov")
  call to_history ("d1",  1.,"rmov")
  call to_history ("d2",  1.,"rmov")
  call to_history ("esize",4,"rmov")
end if


 if(exist_file("xmov"))then  
  call sep_write (xmovie,"xmov")
  call to_history ("n1", nx+na ,"xmov")
  call to_history ("n2",  niter,"xmov")
  call to_history ("o1",  0.,"xmov")
  call to_history ("o2",  0.,"xmov")
  call to_history ("d1",  1.,"xmov")
  call to_history ("d2",  1.,"xmov")
  call to_history ("esize",4,"xmov")
end if




      !write(0,*) 'x out', x
      xx = xk ; aa%flt = aa_dummy%flt
          write(0,*) 'out filter',aa%flt
    end subroutine misif_pef1
end module 
